diff -r f40675df5d4c trytond/modules/account/account.py
--- a/trytond/modules/account/account.py	Fri Sep 21 15:57:18 2012 +0200
+++ b/trytond/modules/account/account.py	Mon Sep 24 20:36:38 2012 +0200
@@ -1183,143 +1088,147 @@
             ])
     print_ = StateAction('account.report_general_ledger')
 
-    def do_print_(self, session, action):
-        if session.start.start_period:
-            start_period = session.start.start_period.id
+    def do_print_(self, action):
+        if self.start.start_period:
+            start_period = self.start.start_period.id
         else:
             start_period = None
-        if session.start.end_period:
-            end_period = session.start.end_period.id
+        if self.start.end_period:
+            end_period = self.start.end_period.id
         else:
             end_period = None
         data = {
-            'company': session.start.company.id,
-            'fiscalyear': session.start.fiscalyear.id,
+            'company': self.start.company.id,
+            'fiscalyear': self.start.fiscalyear.id,
             'start_period': start_period,
             'end_period': end_period,
-            'posted': session.start.posted,
-            'empty_account': session.start.empty_account,
+            'posted': self.start.posted,
+            'empty_account': self.start.empty_account,
             }
         return action, data
 
-    def transition_print_(self, session):
+    def transition_print_(self):
         return 'end'
 
-PrintGeneralLegder()
-
 
 class GeneralLegder(Report):
-    _name = 'account.general_ledger'
+    __name__ = 'account.general_ledger'
 
-    def parse(self, report, objects, data, localcontext):
+    @classmethod
+    def parse(cls, report, objects, data, localcontext):
         pool = Pool()
-        account_obj = pool.get('account.account')
-        period_obj = pool.get('account.period')
-        company_obj = pool.get('company.company')
+        Account = pool.get('account.account')
+        Period = pool.get('account.period')
+        Company = pool.get('company.company')
 
-        company = company_obj.browse(data['company'])
+        company = Company(data['company'])
 
-        account_ids = account_obj.search([
+        accounts = Account.search([
                 ('company', '=', data['company']),
                 ('kind', '!=', 'view'),
                 ], order=[('code', 'ASC'), ('id', 'ASC')])
 
         start_period_ids = [0]
+        start_periods = []
         if data['start_period']:
-            start_period = period_obj.browse(data['start_period'])
-            start_period_ids = period_obj.search([
+            start_period = Period(data['start_period'])
+            start_periods = Period.search([
                     ('fiscalyear', '=', data['fiscalyear']),
                     ('end_date', '<=', start_period.start_date),
                     ])
+            start_period_ids = [p.id for p in start_periods]
 
         with Transaction().set_context(
                 fiscalyear=data['fiscalyear'],
                 periods=start_period_ids,
                 posted=data['posted']):
-            start_accounts = account_obj.browse(account_ids)
+            start_accounts = Account.browse(accounts)
         id2start_account = {}
         for account in start_accounts:
             id2start_account[account.id] = account
 
         end_period_ids = []
         if data['end_period']:
-            end_period = period_obj.browse(data['end_period'])
-            end_period_ids = period_obj.search([
+            end_period = Period(data['end_period'])
+            end_periods = Period.search([
                     ('fiscalyear', '=', data['fiscalyear']),
                     ('end_date', '<=', end_period.start_date),
                     ])
-            if data['end_period'] not in end_period_ids:
-                end_period_ids.append(data['end_period'])
+            if end_period not in end_periods:
+                end_periods.append(end_period)
         else:
-            end_period_ids = period_obj.search([
+            end_periods = Period.search([
                     ('fiscalyear', '=', data['fiscalyear']),
                     ])
+        end_period_ids = [p.id for p in end_periods]
 
         with Transaction().set_context(
                 fiscalyear=data['fiscalyear'],
                 periods=end_period_ids,
                 posted=data['posted']):
-            end_accounts = account_obj.browse(account_ids)
+            end_accounts = Account.browse(accounts)
         id2end_account = {}
         for account in end_accounts:
             id2end_account[account.id] = account
 
-        periods = period_obj.browse(end_period_ids)
+        periods = end_periods
         periods.sort(lambda x, y: cmp(x.start_date, y.start_date))
         localcontext['start_period'] = periods[0]
         periods.sort(lambda x, y: cmp(x.end_date, y.end_date))
         localcontext['end_period'] = periods[-1]
 
         if not data['empty_account']:
-            account_id2lines = self.get_lines(account_ids,
-                end_period_ids, data['posted'])
-            for account_id in (set(account_ids) - set(account_id2lines)):
-                account_ids.remove(account_id)
+            account2lines = cls.get_lines(accounts,
+                end_periods, data['posted'])
+            for account in (set(accounts) - set(account2lines)):
+                accounts.remove(account)
             account_id2lines = None
 
-        account_id2lines = self.lines(account_ids,
-            list(set(end_period_ids).difference(set(start_period_ids))),
+        account_id2lines = cls.lines(accounts,
+            list(set(end_periods).difference(set(start_periods))),
             data['posted'])
 
-        localcontext['accounts'] = account_obj.browse(account_ids)
+        localcontext['accounts'] = accounts
         localcontext['id2start_account'] = id2start_account
         localcontext['id2end_account'] = id2end_account
         localcontext['digits'] = company.currency.digits
         localcontext['lines'] = lambda account_id: account_id2lines[account_id]
         localcontext['company'] = company
 
-        return super(GeneralLegder, self).parse(report, objects, data,
+        return super(GeneralLegder, cls).parse(report, objects, data,
             localcontext)
 
-    def get_lines(self, account_ids, period_ids, posted):
-        move_line_obj = Pool().get('account.move.line')
+    @classmethod
+    def get_lines(cls, accounts, periods, posted):
+        MoveLine = Pool().get('account.move.line')
         clause = [
-            ('account', 'in', account_ids),
-            ('period', 'in', period_ids),
+            ('account', 'in', [a.id for a in accounts]),
+            ('period', 'in', [p.id for p in periods]),
             ('state', '!=', 'draft'),
             ]
         if posted:
             clause.append(('move.state', '=', 'posted'))
-        move_ids = move_line_obj.search(clause, order=[])
+        moves = MoveLine.search(clause, order=[])
         res = {}
-        for move in move_line_obj.browse(move_ids):
-            res.setdefault(move.account.id, []).append(move)
+        for move in moves:
+            res.setdefault(move.account, []).append(move)
         return res
 
-    def lines(self, account_ids, period_ids, posted):
-        move_obj = Pool().get('account.move')
-        res = dict((account_id, []) for account_id in account_ids)
-        account_id2lines = self.get_lines(account_ids, period_ids, posted)
+    @classmethod
+    def lines(cls, accounts, periods, posted):
+        Move = Pool().get('account.move')
+        res = dict((a.id, []) for a in accounts)
+        account2lines = cls.get_lines(accounts, periods, posted)
 
-        state_selections = dict(move_obj.fields_get(
-            fields_names=['state'])['state']['selection'])
+        state_selections = dict(Move.fields_get(
+                fields_names=['state'])['state']['selection'])
 
-        for account_id, lines in account_id2lines.iteritems():
+        for account, lines in account2lines.iteritems():
             lines.sort(lambda x, y: cmp(x.date, y.date))
             balance = Decimal('0.0')
             for line in lines:
                 balance += line.debit - line.credit
-                res[account_id].append({
+                res[account.id].append({
                         'date': line.date,
                         'debit': line.debit,
                         'credit': line.credit,
@@ -1330,13 +1239,10 @@
                         })
         return res
 
-GeneralLegder()
-
 
 class PrintTrialBalanceStart(ModelView):
     'Print Trial Balance'
-    _name = 'account.print_trial_balance.start'
-    _description = __doc__
+    __name__ = 'account.print_trial_balance.start'
     fiscalyear = fields.Many2One('account.fiscalyear', 'Fiscal Year',
             required=True, on_change=['fiscalyear'],
             depends=['start_period', 'end_period'])
@@ -1357,35 +1263,34 @@
     empty_account = fields.Boolean('Empty Account',
             help='With account without move')
 
-    def default_fiscalyear(self):
-        fiscalyear_obj = Pool().get('account.fiscalyear')
-        fiscalyear_id = fiscalyear_obj.find(
-                Transaction().context.get('company'), exception=False)
-        if fiscalyear_id:
-            return fiscalyear_id
+    @staticmethod
+    def default_fiscalyear():
+        FiscalYear = Pool().get('account.fiscalyear')
+        return FiscalYear.find(
+            Transaction().context.get('company'), exception=False)
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def default_posted(self):
+    @staticmethod
+    def default_posted():
         return False
 
-    def default_empty_account(self):
+    @staticmethod
+    def default_empty_account():
         return False
 
-    def on_change_fiscalyear(self, vals):
+    def on_change_fiscalyear(self):
         return {
             'start_period': None,
             'end_period': None,
-        }
-
-PrintTrialBalanceStart()
+            }
 
 
 class PrintTrialBalance(Wizard):
     'Print Trial Balance'
-    _name = 'account.print_trial_balance'
-
+    __name__ = 'account.print_trial_balance'
     start = StateView('account.print_trial_balance.start',
         'account.print_general_ledger_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
@@ -1393,90 +1298,91 @@
             ])
     print_ = StateAction('account.report_trial_balance')
 
-    def do_print_(self, session, action):
-        if session.start.start_period:
-            start_period = session.start.start_period.id
+    def do_print_(self, action):
+        if self.start.start_period:
+            start_period = self.start.start_period.id
         else:
             start_period = None
-        if session.start.end_period:
-            end_period = session.start.end_period.id
+        if self.start.end_period:
+            end_period = self.start.end_period.id
         else:
             end_period = None
         data = {
-            'company': session.start.company.id,
-            'fiscalyear': session.start.fiscalyear.id,
+            'company': self.start.company.id,
+            'fiscalyear': self.start.fiscalyear.id,
             'start_period': start_period,
             'end_period': end_period,
-            'posted': session.start.posted,
-            'empty_account': session.start.empty_account,
+            'posted': self.start.posted,
+            'empty_account': self.start.empty_account,
             }
         return action, data
 
-    def transition_print_(self, session):
+    def transition_print_(self):
         return 'end'
 
-PrintTrialBalance()
-
 
 class TrialBalance(Report):
-    _name = 'account.trial_balance'
+    __name__ = 'account.trial_balance'
 
-    def parse(self, report, objects, data, localcontext):
+    @classmethod
+    def parse(cls, report, objects, data, localcontext):
         pool = Pool()
-        account_obj = pool.get('account.account')
-        period_obj = pool.get('account.period')
-        company_obj = pool.get('company.company')
+        Account = pool.get('account.account')
+        Period = pool.get('account.period')
+        Company = pool.get('company.company')
 
-        company = company_obj.browse(data['company'])
+        company = Company(data['company'])
 
-        account_ids = account_obj.search([
-            ('company', '=', data['company']),
-            ('kind', '!=', 'view'),
-            ])
+        accounts = Account.search([
+                ('company', '=', data['company']),
+                ('kind', '!=', 'view'),
+                ])
 
-        start_period_ids = [0]
+        start_periods = []
         if data['start_period']:
-            start_period = period_obj.browse(data['start_period'])
-            start_period_ids = period_obj.search([
+            start_period = Period(data['start_period'])
+            start_periods = Period.search([
                     ('fiscalyear', '=', data['fiscalyear']),
                     ('end_date', '<=', start_period.start_date),
                     ])
 
-        end_period_ids = []
         if data['end_period']:
-            end_period = period_obj.browse(data['end_period'])
-            end_period_ids = period_obj.search([
+            end_period = Period(data['end_period'])
+            end_periods = Period.search([
                     ('fiscalyear', '=', data['fiscalyear']),
                     ('end_date', '<=', end_period.start_date),
                     ])
-            end_period_ids = list(set(end_period_ids).difference(
-                    set(start_period_ids)))
-            if data['end_period'] not in end_period_ids:
-                end_period_ids.append(data['end_period'])
+            end_periods = list(set(end_periods).difference(
+                    set(start_periods)))
+            if end_period not in end_periods:
+                end_periods.append(end_period)
         else:
-            end_period_ids = period_obj.search([
+            end_periods = Period.search([
                     ('fiscalyear', '=', data['fiscalyear']),
                     ])
-            end_period_ids = list(set(end_period_ids).difference(
-                    set(start_period_ids)))
+            end_periods = list(set(end_periods).difference(
+                    set(start_periods)))
+
+        start_period_ids = [p.id for p in start_periods] or [0]
+        end_period_ids = [p.id for p in end_periods]
 
         with Transaction().set_context(
                 fiscalyear=data['fiscalyear'],
                 periods=start_period_ids,
                 posted=data['posted']):
-            start_accounts = account_obj.browse(account_ids)
+            start_accounts = Account.browse(accounts)
 
         with Transaction().set_context(
                 fiscalyear=None,
                 periods=end_period_ids,
                 posted=data['posted']):
-            in_accounts = account_obj.browse(account_ids)
+            in_accounts = Account.browse(accounts)
 
         with Transaction().set_context(
                 fiscalyear=data['fiscalyear'],
                 periods=start_period_ids + end_period_ids,
                 posted=data['posted']):
-            end_accounts = account_obj.browse(account_ids)
+            end_accounts = Account.browse(accounts)
 
         to_remove = []
         if not data['empty_account']:
@@ -1499,7 +1405,7 @@
                     'end_balance': end_account.balance,
                     })
 
-        periods = period_obj.browse(end_period_ids)
+        periods = end_periods
 
         localcontext['accounts'] = accounts
         periods.sort(key=operator.attrgetter('start_date'))
@@ -1508,45 +1414,43 @@
         localcontext['end_period'] = periods[-1]
         localcontext['company'] = company
         localcontext['digits'] = company.currency.digits
-        localcontext['sum'] = lambda accounts, field: self.sum(accounts, field)
+        localcontext['sum'] = lambda accounts, field: cls.sum(accounts, field)
 
-        return super(TrialBalance, self).parse(report, objects, data,
+        return super(TrialBalance, cls).parse(report, objects, data,
             localcontext)
 
-    def sum(self, accounts, field):
+    @classmethod
+    def sum(cls, accounts, field):
         amount = Decimal('0.0')
         for account in accounts:
             amount += account[field]
         return amount
 
-TrialBalance()
-
 
 class OpenBalanceSheetStart(ModelView):
     'Open Balance Sheet'
-    _name = 'account.open_balance_sheet.start'
-    _description = __doc__
+    __name__ = 'account.open_balance_sheet.start'
     date = fields.Date('Date', required=True)
     company = fields.Many2One('company.company', 'Company', required=True)
     posted = fields.Boolean('Posted Move', help='Show only posted move')
 
-    def default_date(self):
-        date_obj = Pool().get('ir.date')
-        return date_obj.today()
+    @staticmethod
+    def default_date():
+        Date_ = Pool().get('ir.date')
+        return Date_.today()
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def default_posted(self):
+    @staticmethod
+    def default_posted():
         return False
 
-OpenBalanceSheetStart()
-
 
 class OpenBalanceSheet(Wizard):
     'Open Balance Sheet'
-    _name = 'account.open_balance_sheet'
-
+    __name__ = 'account.open_balance_sheet'
     start = StateView('account.open_balance_sheet.start',
         'account.open_balance_sheet_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
@@ -1554,38 +1458,34 @@
             ])
     open_ = StateAction('account.act_account_balance_sheet_tree')
 
-    def do_open_(self, session, action):
+    def do_open_(self, action):
         pool = Pool()
-        lang_obj = pool.get('ir.lang')
+        Lang = pool.get('ir.lang')
 
-        company = session.start.company
-        lang_id, = lang_obj.search([
+        company = self.start.company
+        lang, = Lang.search([
                 ('code', '=', Transaction().language),
                 ])
-        lang = lang_obj.browse(lang_id)
 
-        date = lang_obj.strftime(session.start.date, lang.code, lang.date)
+        date = Lang.strftime(self.start.date, lang.code, lang.date)
 
         action['pyson_context'] = PYSONEncoder().encode({
-                'date': Date(session.start.date.year,
-                    session.start.date.month,
-                    session.start.date.day),
-                'posted': session.start.posted,
+                'date': Date(self.start.date.year,
+                    self.start.date.month,
+                    self.start.date.day),
+                'posted': self.start.posted,
                 'company': company.id,
                 })
-        action['name'] += ' - ' + date + ' - ' + company.name
+        action['name'] += '%s - %s' % (date, company.name)
         return action, {}
 
-    def transition_open_(self, session):
+    def transition_open_(self):
         return 'end'
 
-OpenBalanceSheet()
-
 
 class OpenIncomeStatementStart(ModelView):
     'Open Income Statement'
-    _name = 'account.open_income_statement.start'
-    _description = __doc__
+    __name__ = 'account.open_income_statement.start'
     fiscalyear = fields.Many2One('account.fiscalyear', 'Fiscal Year',
             required=True, on_change=['fiscalyear'],
             depends=['start_period', 'end_period'])
@@ -1604,32 +1504,30 @@
     company = fields.Many2One('company.company', 'Company', required=True)
     posted = fields.Boolean('Posted Move', help='Show only posted move')
 
-    def default_fiscalyear(self):
-        fiscalyear_obj = Pool().get('account.fiscalyear')
-        fiscalyear_id = fiscalyear_obj.find(
-                Transaction().context.get('company'), exception=False)
-        if fiscalyear_id:
-            return fiscalyear_id
+    @staticmethod
+    def default_fiscalyear():
+        FiscalYear = Pool().get('account.fiscalyear')
+        return FiscalYear.find(
+            Transaction().context.get('company'), exception=False)
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def default_posted(self):
+    @staticmethod
+    def default_posted():
         return False
 
-    def on_change_fiscalyear(self, vals):
+    def on_change_fiscalyear(self):
         return {
             'start_period': None,
             'end_period': None,
         }
 
-OpenIncomeStatementStart()
-
 
 class OpenIncomeStatement(Wizard):
     'Open Income Statement'
-    _name = 'account.open_income_statement'
-
+    __name__ = 'account.open_income_statement'
     start = StateView('account.open_income_statement.start',
         'account.open_income_statement_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
@@ -1637,70 +1535,62 @@
             ])
     open_ = StateAction('account.act_account_income_statement_tree')
 
-    def do_open_(self, session, action):
+    def do_open_(self, action):
         pool = Pool()
-        period_obj = pool.get('account.period')
+        Period = pool.get('account.period')
 
-        start_period_ids = [0]
-        if session.start.start_period:
-            start_period_ids = period_obj.search([
-                    ('fiscalyear', '=', session.start.fiscalyear.id),
-                    ('end_date', '<=', session.start.start_period.start_date),
+        start_periods = []
+        if self.start.start_period:
+            start_periods = Period.search([
+                    ('fiscalyear', '=', self.start.fiscalyear.id),
+                    ('end_date', '<=', self.start.start_period.start_date),
                     ])
 
-        end_period_ids = []
-        if session.start.end_period:
-            end_period_ids = period_obj.search([
-                    ('fiscalyear', '=', session.start.fiscalyear.id),
-                    ('end_date', '<=', session.start.end_period.start_date),
+        end_periods = []
+        if self.start.end_period:
+            end_periods = Period.search([
+                    ('fiscalyear', '=', self.start.fiscalyear.id),
+                    ('end_date', '<=', self.start.end_period.start_date),
                     ])
-            end_period_ids = list(set(end_period_ids).difference(
-                    set(start_period_ids)))
-            if session.start.end_period.id not in end_period_ids:
-                end_period_ids.append(session.start.end_period.id)
+            end_periods = list(set(end_periods).difference(
+                    set(start_periods)))
+            if self.start.end_period not in end_periods:
+                end_periods.append(self.start.end_period)
         else:
-            end_period_ids = period_obj.search([
-                    ('fiscalyear', '=', session.start.fiscalyear.id),
+            end_periods = Period.search([
+                    ('fiscalyear', '=', self.start.fiscalyear.id),
                     ])
-            end_period_ids = list(set(end_period_ids).difference(
-                    set(start_period_ids)))
+            end_periods = list(set(end_periods).difference(
+                    set(start_periods)))
 
         action['pyson_context'] = PYSONEncoder().encode({
-                'periods': end_period_ids,
-                'posted': session.start.posted,
-                'company': session.start.company.id,
+                'periods': [p.id for p in end_periods],
+                'posted': self.start.posted,
+                'company': self.start.company.id,
                 })
         return action, {}
 
-OpenIncomeStatement()
-
 
 class CreateChartStart(ModelView):
     'Create Chart'
-    _name = 'account.create_chart.start'
-    _description = __doc__
-
-CreateChartStart()
+    __name__ = 'account.create_chart.start'
 
 
 class CreateChartAccount(ModelView):
     'Create Chart'
-    _name = 'account.create_chart.account'
-    _description = __doc__
+    __name__ = 'account.create_chart.account'
     company = fields.Many2One('company.company', 'Company', required=True)
     account_template = fields.Many2One('account.account.template',
             'Account Template', required=True, domain=[('parent', '=', None)])
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-CreateChartAccount()
 
-
-class CreateChartPropertites(ModelView):
+class CreateChartProperties(ModelView):
     'Create Chart'
-    _name = 'account.create_chart.properties'
-    _description = __doc__
+    __name__ = 'account.create_chart.properties'
     company = fields.Many2One('company.company', 'Company')
     account_receivable = fields.Many2One('account.account',
             'Default Receivable Account',
@@ -1717,13 +1607,10 @@
             ],
             depends=['company'])
 
-CreateChartPropertites()
-
 
 class CreateChart(Wizard):
     'Create Chart'
-    _name = 'account.create_chart'
-
+    __name__ = 'account.create_chart'
     start = StateView('account.create_chart.start',
         'account.create_chart_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
